Draft BSpline: Difference between revisions

From FreeCAD Documentation
mNo edit summary
(2 intermediate revisions by the same user not shown)
Line 60: Line 60:
* Press {{KEY|G}} or click the {{MenuCommand|Global}} checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the [[Draft_SelectPlane|working plane]] coordinate system. {{Version|0.20}}
* Press {{KEY|G}} or click the {{MenuCommand|Global}} checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the [[Draft_SelectPlane|working plane]] coordinate system. {{Version|0.20}}
* Press {{KEY|L}} or click the {{MenuCommand|Filled}} checkbox to toggle filled mode. If filled mode is on, the created spline will have {{PropertyData|Make Face}} set to {{TRUE}} and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting spline with a face will not display properly, for such a spline {{PropertyData|Make Face}} must be set to {{FALSE}}.
* Press {{KEY|L}} or click the {{MenuCommand|Filled}} checkbox to toggle filled mode. If filled mode is on, the created spline will have {{PropertyData|Make Face}} set to {{TRUE}} and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting spline with a face will not display properly, for such a spline {{PropertyData|Make Face}} must be set to {{FALSE}}.
* Press {{KEY|T}} or click the {{MenuCommand|Continue}} checkbox to toggle continue mode. If continue mode is on, the command will restart after using {{Button|[[Image:Draft_FinishLine.svg|16px]] Finish}} or {{Button|[[Image:Draft_CloseLine.svg|16px]] Close}}, or after creating a closed spline by snapping to the first point of the spline, allowing you to continue drawing splines.
* Press {{KEY|T}} or click the {{MenuCommand|Continue}} checkbox to toggle continue mode. If continue mode is on, the command will restart after using {{Button|[[Image:Draft_FinishLine.svg|16px]] Finish}} or {{Button|[[Image:Draft_CloseLine.svg|16px]] Close}}, or after creating a closed spline by snapping to the first point of the spline, allowing you to continue creating splines.
* Press the {{button|[[Image:Draft_UndoLine.svg|16px]] Undo}} button to undo the last point. The {{KEY|Ctrl}}+{{KEY|Z}} keyboard shortcut currently does not work.
* Press the {{button|[[Image:Draft_UndoLine.svg|16px]] Undo}} button to undo the last point. The {{KEY|Ctrl}}+{{KEY|Z}} keyboard shortcut currently does not work.
* Press {{KEY|A}} or the {{Button|[[Image:Draft_FinishLine.svg|16px]] Finish}} button to finish the command and leave the spline open.
* Press {{KEY|A}} or the {{Button|[[Image:Draft_FinishLine.svg|16px]] Finish}} button to finish the command and leave the spline open.
Line 117: Line 117:
** Each point in the list is defined by its {{incode|FreeCAD.Vector}}, with units in millimeters.
** Each point in the list is defined by its {{incode|FreeCAD.Vector}}, with units in millimeters.
** Alternatively, the input can be a {{incode|Part.Wire}}, from which points are extracted.
** Alternatively, the input can be a {{incode|Part.Wire}}, from which points are extracted.
* If {{incode|closed}} is {{incode|True}}, or if the first and last points are identical, the wire is closed.
* If {{incode|closed}} is {{incode|True}}, or if the first and last points are identical, the spline is closed.
* If {{incode|placement}} is {{incode|None}} the shape is created at the origin.
* If {{incode|placement}} is {{incode|None}} the spline is created at the origin.
* If {{incode|face}} is {{incode|True}}, and the spline is closed, the spline will make a face, that is, it will appear filled.
* If {{incode|face}} is {{incode|True}}, and the spline is closed, the spline will make a face, that is, it will appear filled.



Revision as of 15:46, 3 May 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft BSpline

Menu location
Drafting → B-spline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
0.7
See also
Draft Wire, Draft CubicBezCurve, Draft BezCurve

Description

The Draft BSpline command creates a B-spline curve from several points.

The Draft BSpline command specifies the exact points through which the curve will pass. The Draft BezCurve and the Draft CubicBezCurve commands, on the other hand, use control points to define the position and curvature of the spline.

Spline defined by multiple points

Usage

See also: Draft Tray, Draft Snap and Draft Constrain.

  1. There are several ways to invoke the command:
    • Press the Draft BSpline button.
    • Select the Drafting → B-spline option from the menu.
    • Use the keyboard shortcut: B then S.
  2. The B-spline task panel opens. See Options for more information.
  3. Pick the first point in the 3D view, or type coordinates and press the Enter point button.
  4. Pick additional points in the 3D view, or type coordinates and press the Enter point button.
  5. Press Esc or the Close button to finish the command.

Options

The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts.

  • To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, coordinates are relative to the last point, if available, else they are relative to the coordinate system origin.
  • Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
  • Press L or click the Filled checkbox to toggle filled mode. If filled mode is on, the created spline will have DataMake Face set to true and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting spline with a face will not display properly, for such a spline DataMake Face must be set to false.
  • Press T or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after using Finish or Close, or after creating a closed spline by snapping to the first point of the spline, allowing you to continue creating splines.
  • Press the Undo button to undo the last point. The Ctrl+Z keyboard shortcut currently does not work.
  • Press A or the Finish button to finish the command and leave the spline open.
  • Press O or the Close button to finish the command and close the spline. A closed spline can also be created by snapping to the first point of the spline.
  • Press W or the Wipe button to delete the curve segments already placed, but keep working from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation defined by the last and the previous point.
  • Press Esc or the Close button to finish the command.

Notes

Properties

See also: Property editor.

A Draft BSpline object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Data

  • DataArea (Area): (read-only) specifies the area of the face of the spline. The value will be 0.0 if DataMake Face if false or the face cannot be created.
  • DataClosed (Bool): specifies if the spline is closed or not. If the spline is initially open this value is false, setting it to true will draw a curve segment to close the spline. If the spline is initially closed this value is true, setting it to false will remove the last curve segment and make the spline open.
  • DataMake Face (Bool): specifies if the spline makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed is true and if the spline does not self-intersect.
  • DataParameterization (Float): affects the shape of the spline.
  • DataPoints (VectorList): specifies the points of the spline in its local coordinate system.

View

  • ViewArrow Size (Length): specifies the size of the symbol displayed at the end of the spline.
  • ViewArrow Type (Enumeration): specifies the type of symbol displayed at the end of the spline, which can be Dot, Circle, Arrow, Tick or Tick-2.
  • ViewEnd Arrow (Bool): specifies whether to show a symbol at the end of the spline, so it can be used as an annotation line.
  • ViewPattern (Enumeration): specifies the Draft Pattern with which to fill the face of the closed spline. This property only works if DataMake Face is true and if ViewDisplay Mode is Flat Lines.
  • ViewPattern Size (Float): specifies the size of the Draft Pattern.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft BSpline use the make_bspline method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBSpline method.

bspline = make_bspline(pointslist, closed=False, placement=None, face=None, support=None)
bspline = make_bspline(Part.Wire, closed=False, placement=None, face=None, support=None)
  • Creates a bspline object from the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the spline is closed.
  • If placement is None the spline is created at the origin.
  • If face is True, and the spline is closed, the spline will make a face, that is, it will appear filled.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)

spline1 = Draft.make_bspline([p1, p2, p3], closed=False)
spline2 = Draft.make_bspline([p1, 2*p3, 1.3*p2], closed=False)
spline3 = Draft.make_bspline([1.3*p3, p1, -1.7*p2], closed=False)

doc.recompute()